local _, RS = ...
RS.Common = {}
local Common = RS.Common

-- actions that describe what the spell/event is
Common.ActionType = {
	HIT          = 1,
	MISS         = 2,
	START_CAST   = 3,
	PERIODIC     = 4,
	CHANNEL_STOP = 5,
	AURA_GAINED  = 6,
	AURA_REMOVED = 7,
	EVENT_AURA   = 8,
}

-- return true if target has an aura
function Common.HasAura(target, auraName)
	local found = false
	local name
	for i=1,40 do
		name = UnitDebuff(target, i)
		if not name then
			break
		elseif name == auraName then
			return true
		end
	end
	for i=1,40 do
		name = UnitBuff(target, i)
		if not name then
			break
		elseif name == auraName then
			return true
		end
	end
end

-- return the lowest durability percent found from all equipped items
function Common.GetLowestEquipmentDurability()
	local current, maximum, percent, lowest
	for i=1,18 do
		current, maximum = GetInventoryItemDurability(i)
		if current then
			percent = current / maximum * 100
			if not lowest or percent < lowest then
				lowest = percent
			end
		end
	end
	return lowest
end

-- table of bosses that aren't actually classified as bosses - used in conditions and events
Common.bossList = {
	-- Auchindoun: Auchenai Crypts
	["Shirrak the Dead Watcher"]=1,
	["Exarch Maladaar"]=1,
	["Avatar of the Martyred"]=1,
	-- Auchindoun: Mana Tombs
	["Pandemonius"]=1,
	["Tavarok"]=1,
	["Nexus-Prince Shaffar"]=1,
	-- Auchindoun: Sethekk Halls
	["Darkweaver Syth"]=1,
	["Talon King Ikiss"]=1,
	-- Auchindoun: Shadow Labyrinth
	["Ambassador Hellmaw"]=1,
	["Blackheart the Inciter"]=1,
	["Grandmaster Vorpil"]=1,
	["Murmur"]=1,
	-- Caverns of Time: Old Hillsbrad Foothills
	["Lieutenant Drake"]=1,
	["Captain Skarloc"]=1,
	["Epoch Hunter"]=1,
	-- Caverns of Time: The Black Morass
	["Chrono Lord Deja"]=1,
	["Temporus"]=1,
	["Aeonus"]=1,
	-- Coilfang Reservoir: The Slave Pens
	["Ahune"]=1,
	["Mennu the Betrayer"]=1,
	["Rokmar the Crackler"]=1,
	["Quagmirran"]=1,
	-- Coilfang Reservoir: The Steamvault
	["Hydromancer Thespia"]=1,
	["Mekgineer Steamrigger"]=1,
	["Warlord Kalithresh"]=1,
	-- Coilfang Reservoir: The Underbog
	["Hungarfen"]=1,
	["Ghaz'an"]=1,
	["Swamplord Musel'ek"]=1,
	["The Black Stalker"]=1,
	-- Hellfire Citadel: Hellfire Ramparts
	["Watchkeeper Gargolmar"]=1,
	["Omor the Unscarred"]=1,
	["Vazruden"]=1,
	-- Hellfire Citadel: The Blood Furnace
	["The Maker"]=1,
	["Broggok"]=1,
	["Keli'dan the Breaker"]=1,
	-- Hellfire Citadel: The Shattered Halls
	["Grand Warlock Nethekurse"]=1,
	["Blood Guard Porung"]=1,
	["Warbringer O'mrogg"]=1,
	["Warchief Kargath Bladefist"]=1,
	-- Magisters' Terrace
	["Selin Fireheart"]=1,
	["Vexallus"]=1,
	["Priestess Delrissa"]=1,
	["Kael'thas Sunstrider"]=1,
	-- Tempest Keep: The Arcatraz
	["Zereketh the Unbound"]=1,
	["Dalliah the Doomsayer"]=1,
	["Wrath-Scryer Soccothrates"]=1,
	["Harbinger Skyriss"]=1,
	-- Tempest Keep: The Botanica
	["Commander Sarannis"]=1,
	["High Botanist Freywinn"]=1,
	["Thorngrin the Tender"]=1,
	["Laj"]=1,
	["Warp Splinter"]=1,
	-- Tempest Keep: The Mechanar
	["Mechano-Lord Capacitus"]=1,
	["Nethermancer Sepethrea"]=1,
	["Pathaleon the Calculator"]=1,
}